//ŏIXVF2007-11-20

/*----------------------------------------------------------------------------
ETv
	\tgEFAI2C
	vAbv̓n[hEFAō\z
	H = in  High-Z
	L = out Low

Eӎ

	WinAVRRpCpC\[XR[h
----------------------------------------------------------------------------*/
#ifndef __S_IIC_H__
#define __S_IIC_H__

/*----------------------------------------------------------------------------
CN[hA`Ȃ
----------------------------------------------------------------------------*/
#include <avr/io.h>

//|[g`
#define IIC_PORT PORTB
#define IIC_DDR DDRB
#define IIC_PIN PINB

//|[gԍ`
#define IIC_SCL 3
#define IIC_SDA 4


/*----------------------------------------------------------------------------
}N
----------------------------------------------------------------------------*/
#define IIC_NOP() __asm__ __volatile__ ("nop")

//Z(L)min = H
#define IIC_SDA_H() \
		IIC_PORT&=~_BV(IIC_SDA); \
		IIC_DDR&=~_BV(IIC_SDA)
//L(Z)out = L
#define IIC_SDA_L() \
		IIC_PORT&=~_BV(IIC_SDA); \
		IIC_DDR|=_BV(IIC_SDA)
//Z(L)min = H
#define IIC_SCL_H() \
		IIC_PORT&=~_BV(IIC_SCL); \
		IIC_DDR&=~_BV(IIC_SCL)
//L(Z)out = L
#define IIC_SCL_L() \
		IIC_PORT&=~_BV(IIC_SCL); \
		IIC_DDR|=_BV(IIC_SCL)

//}N֐
#define IIC_Bit() ((IIC_PIN >> IIC_SDA) & 0x01) //1rbgǂݍ
#define IIC_Wait() while( !(IIC_PIN & _BV(IIC_SCL)) ) //SCL=H܂őҋ@
#define IIC_Init() IIC_Start(),IIC_Send(0xFF),IIC_Start();IIC_Stop() //IICoX

/*----------------------------------------------------------------------------
֐
----------------------------------------------------------------------------*/
uint8_t IIC_Send(uint8_t);
uint8_t IIC_Recv(uint8_t);
void IIC_Stop(void);
void IIC_Start(void);


//----------------------------------------------------------------------------
//yT@vzIIC 1oCgM
//y@zMf[^MSB[7]...LSB[0] MSB瑗M
//y߂lz0=ACKLow 1=NAKHigh
uint8_t IIC_Send(uint8_t dat)
{
	uint8_t ret;
	uint8_t lp = 8;
	while(lp--)
	{
		IIC_SCL_L();//SDAZbg
		if(dat & 0x80)
		{
			IIC_SDA_H();
		}
		else
		{
			IIC_SDA_L();
		}
		dat<<=1;
		IIC_SCL_H();//Ŋm
		IIC_Wait();//҂(SCLHɂȂ܂ő҂)
	}

	//X[u
	IIC_SCL_L();//
	IIC_SDA_H();//SDAJ
	IIC_NOP();
	IIC_SCL_H();//Hɂ
	IIC_Wait();//HɂȂ܂ő҂
	ret = IIC_Bit();//ǂݎ
	IIC_SCL_L();//̂߂ɃNbNSDAJ
	
	return ret;
}
//----------------------------------------------------------------------------
//yT@vzIIC 1oCgM
//y@zreply  1=NAK(H) 0=ACK(L)
//y߂lzMf[^
uint8_t IIC_Recv(uint8_t reply)
{
	uint8_t recv = 0x00;
	uint8_t lp = 8;

	while(lp--)
	{
		IIC_SCL_L();//SDAωłԂ
		IIC_SDA_H();//SDAmɊJ
		IIC_SCL_H();//Hɂ
		IIC_Wait();//肪o͂ASCL=HɂȂ܂ő҂
		recv<<=1;
		recv |= IIC_Bit();//ǂݎ
	}
	//
	IIC_SCL_L();//Lɂ
	if(reply)//Zbg
	{
		IIC_SDA_H();
	}
	else
	{
		IIC_SDA_L();
	}
	IIC_SCL_H();//H߂
	IIC_Wait();//HɂȂ܂ő҂
	IIC_SCL_L();//̂߂ɃNbNSDAJ

	return recv;
}
//----------------------------------------------------------------------------
//yT@vzIIC XgbvRfBVM
//y@z
//y߂lz
void IIC_Stop(void)
{
	//XgbvRfBV̑ÓAʏSCL=L,SDA=H/L
	IIC_SDA_L();//SCL=LʏωASCL=HX^[gRfBV
	IIC_SCL_L();//mSCL=LāA
	IIC_NOP();
	IIC_SCL_H();//SCL=H
	IIC_SDA_H();//SDAŁAXgbvRfBV
	return;
}
//----------------------------------------------------------------------------
//yT@vzIIC X^[gRfBVM
//y@z
//y߂lz
void IIC_Start(void)
{
	//X^[gRfBV̑ÓAʏSCL=H,SDA=H
	IIC_SDA_H();//SCL=LʏωASCL=HXgbvRfBV
	IIC_SCL_H();//mSCL=HāA
	IIC_NOP();
	IIC_SDA_L();//SDAŁAX^[gRfBV
	return;
}
//----------------------------------------------------------------------------
#endif
